
 #include <built_in.h>

long volt;
unsigned int adc_rd=0;

sbit LCD_RS at PORTD2_bit;
sbit LCD_EN at PORTD3_bit;
sbit LCD_D4 at PORTD4_bit;
sbit LCD_D5 at PORTD5_bit;
sbit LCD_D6 at PORTD6_bit;
sbit LCD_D7 at PORTD7_bit;

sbit LCD_RS_Direction at DDD2_bit;
sbit LCD_EN_Direction at DDD3_bit;
sbit LCD_D4_Direction at DDD4_bit;
sbit LCD_D5_Direction at DDD5_bit;
sbit LCD_D6_Direction at DDD6_bit;
sbit LCD_D7_Direction at DDD7_bit;

unsigned int ADC_value(short int canal)
{       unsigned int valor =0;

	// ADC channel selection.
	ADMUX &=~  0x0F;
	ADMUX |=  canal;

	// Turn on the ADC.
	ADCSRA |= (1<<ADEN);
	delay_us(10);	// wait a moment for the stability.

	// Send the sampling.
	ADCSRA |= (1<<ADSC);

	// Wait for the sampling and after that read the flag.
	while( !(ADCSRA & (1<<ADIF)) );
	ADCSRA |= (1<<ADIF);	// Reset the flag.

	// Turn off the ADC.
	ADCSRA &=~ (1<<ADEN);
      valor = ADCL;      //Merge the adcl register with adch register and
      valor |= ADCH<<8;   //after that send the result.
   return valor;
}

void  printV() {
 unsigned char ch ;

    ch = volt / 1000;
    Lcd_Chr(2,6,48+ch);
    Lcd_Chr(2,7,'.');
    ch = (volt / 100 )% 10;
    Lcd_Chr_CP(48+ch);
    ch = (volt / 10 )% 10;
    Lcd_Chr_CP(48+ch);
    ch = volt % 10;
    Lcd_Chr_CP(48+ch);
    Delay_ms(50);
}

void  ADC_SET_UP() {

   // Initialize the ADC.
   ADMUX &=~ (1<<ADLAR);

 //  Reference voltage  = AVCC.
   ADMUX |=  (1<<REFS0);
   ADMUX &=~ (1<<REFS1);

// Frequency divisor = 128 -> 16000/128 = 125 KHz.
    ADCSRA |= (1<<ADPS0);
    ADCSRA |= (1<<ADPS1);
    ADCSRA |= (1<<ADPS2);
}
void main() {

    DDC2_bit=0;
    ADC_SET_UP();
    Lcd_Init();                        // Initialize LCD.
    Lcd_Cmd(_LCD_CLEAR);               // Clear display.
    Lcd_Cmd(_LCD_CURSOR_OFF);          // Cursor off.
    Lcd_Out(1, 4, "Voltage");

  while (1) {

    adc_rd= ADC_value(2);
    volt = (long)adc_rd * 5000; //get the voltage values.
    volt = volt / 1023;
    delay_ms(10);
    printV();
  }
}